<p align="center" width="100%">
<img src="https://i.mji.rip/2023/10/13/c4bdc6505f2b3f2304bffb5ea196f5a2.png"  width="40%" height="80%">
</p>
<div>
<div align="center">
<font size=5><strong>Octopus: Embodied Vision-Language Programmer from Environmental Feedback</strong></font>

## 🐙 Introducing Octopus
Octopus is a novel VLM designed to proficiently decipher an agent’s vision and textual task objectives and to formulate intricate action sequences and generate executable code.

This repository provides:
- Training data collection pipeline in `octogibson` environment,
- Evaluation pipeline in `octogibson` environment,
- Evaluation pipeline in `octogta` environment,
- Training pipeline of the `octopus` model.

## 🏁 Get Started
1. **Training Data Collection:** For data collection from `octogibson` environment, you need to set up two conda environments: `omnigibson` and `gpt4`. The `omnigibson` environment has an agent to act following the instruction from `gpt4` environment. Please checkout [here](octogibson/README.md) for detailed information.
2. **Evaluation in OctoGibson:** We provide the pipeline that the simulator sends messages to the Octopus server and gets responses to control the agent.
3. **Evaluation in OctoGTA:** We provide instructions, code, and MOD so that the Octopus can complete tasks in the GTA environment. Please checkout [here](octogta/README.md) for detailed information.
4. **Octopus Training:** We provide code for training Octopus. Please checkout [here](octopus/README.md) for detailed information.
